    // Copyright (c) 2008 Pedro Quaresma, Coimbra, Portugal
    // Versão 2.0 
    // versão 1.0, desenvolvida por Augusto Pinho
    //   (sob supervisão de Pedro Quaresma)


%{


int nhifens() {
  int i,nhfs=0;
  
  for (i=0;i<yyleng;i++)
    if(yytext[i]=='-')
      nhfs++;
  return(nhfs);
}

%}


   int i;
   int j=0;
   double totalPalavras=0;     
   double total_letras=0;

letras [a-zA-Z]|"á"|"à"|"ã"|"â"|"ç"|"é"|"è"|"ê"|"í"|"ì"|"ó"|"ò"|"õ"|"ô"|"ú"|"ù"|"ü"|"Á"|"À"|"Ã"|"Â"|"Ç"|"É"|"È"|"Ê"|"Í"|"Ì"|"Ó"|"Ò"|"Õ"|"Ô"|"Ú"|"Ù"|"Ü"|"-"


  /*
    Ao colocar como "letra" (nas "palavras") o caracter '-' está-se a
    considerar as palavras do tipo ab-cd, em que "a" é a primeira
    letra, e "d" a última, sendo que "b" e "c" são letras no meio.

    É de notar que se considerou que:

    *) uma palavra do tipo "manda-chuva" conta como uma só palavra.
    *) o "-" não conta como letra.

    Os Textos devem ser tratados de forma a retirar os casos de
    hifenização, esses casos não podem ser tratados simplesmente com o
    Flex, requerem o Bison dado que se tem de ter em conta a estrutura
    da frase (uma linha a acabar em "-" com outra a começar também com
    um "-".

    Devem também ser retirados todos as sequência de mais do que um hífen
  */


%% 

 
{letras}+ { 
            if(yytext[0]!='-' || yyleng>1) {
              total_letras = total_letras+yyleng-nhifens();
	      totalPalavras++;  
	    }
          }                                       

.|\n      

%%

int main(int argc, char *argv[]) {

  // interface linha de comando
  // media <nome_de_ficheiro_entrada> <nome_de_ficheiro_saida>

  char *ficheiroEntrada,*ficheiroSaida;

  FILE *fsai, *fopen();
  
  if (argc<=2) { // valores de entrada insuficientes (2+1)
    printf("\nUtilização: media nome_ficheiro_entrada nome_ficheiro_saída\n\n");
    return;
  }
  // obtêm os argumentos da linha de comando
  ficheiroEntrada=argv[1];
  ficheiroSaida=argv[2];
  printf ("\nFicheiro a Processar: %s\nFicheiro com resultados: %s\n\n",ficheiroEntrada,ficheiroSaida);

  if ((yyin = fopen(ficheiroEntrada,"r")) == NULL) {
    printf("Não foi possível abrir o ficheiro %s\n",ficheiroEntrada);
  } else if ((fsai = fopen(ficheiroSaida,"w")) == NULL) {
    printf("Não foi possível abrir para escrita o ficheiro %s\n",ficheiroSaida);
  } else {
    // processar
    yylex();       
    fprintf(fsai,"\n\nResultados:\n\n");
    fprintf(fsai,"Total de Letras:  %0.0f \n", total_letras);
    fprintf(fsai,"Total de Palavras:  %0.0f \n", totalPalavras);
    fprintf(fsai,"Comprimento Médio das Palavras: %0.6f\n\n", total_letras / totalPalavras);
    fclose(fsai);
  }
}
